//-----------------------------------------------------
//	Xt@Cǂݍ݁A`Tv
//	2010.02.05 TMO
//-----------------------------------------------------

#include "stdafx.h"
#include "Graphic.h"

CGraphic*				glbl_graphic = NULL;

LPDIRECT3D9				g_pD3D = NULL;			//D3DC^[tF[X D3DfoCX̂ɕKv
LPDIRECT3DDEVICE9		g_pD3DDevice = NULL;	//D3DfoCX `ȂǍL͈͂ŕKvɂȂB
IDirect3DVertexBuffer9* g_pVB = NULL;			//|S̃obt@

//̃R[h쐬ꂽD3DfoCX擾邽߂̂
extern LPDIRECT3DDEVICE9 GetDevice()
{
	return g_pD3DDevice;
}

//CGraphic̍쐬
CGraphic* CreateGraphic( HWND hWnd )
{
	glbl_graphic = new CGraphic();
	glbl_graphic->Create( hWnd );
	return glbl_graphic;
}

//CGraphic̎擾
CGraphic* GetGraphic() { return glbl_graphic; }

//CGraphic̉
void ReleaseGraphic()
{
	if ( glbl_graphic ) {
		glbl_graphic->Destroy();
		delete glbl_graphic;
		glbl_graphic = NULL;
	}
}


CGraphic::CGraphic()
{
	if ( g_pD3D != NULL ) {
		//CGraphic͂QȂB
		_ASSERT(0);
	}

	m_backColor = 0xFF0505FF;

	m_currDisplayMode = DisplayMode::WindowMode;

	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	g_pD3DDevice   = NULL;
}
CGraphic::~CGraphic()
{
	Destroy();
}

//CGraphic̍쐬
void CGraphic::Destroy()
{
	//D3DfoCX
	if( g_pD3DDevice )
	{
		g_pD3DDevice->Release();
		g_pD3DDevice = NULL;
	}

	//D3DC^[tF[X
	if( g_pD3D )
	{
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}

//CGraphic̍쐬( Direct3D̏ )
bool CGraphic::Create(HWND hWnd)
{
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if ( g_pD3D == NULL ) {
		return false;
	}
	
	//D3DPRESENT_PARAMETERS\̏̂߃fBXvC[h擾
	D3DDISPLAYMODE dmode;
	ZeroMemory( &dmode, sizeof( dmode ) );
	g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT , &dmode );
	
	//foCX̏Ԃw肷
	D3DPRESENT_PARAMETERS	d3dpp;
	ZeroMemory( &d3dpp, sizeof( d3dpp ) );
	{

		switch ( m_currDisplayMode ) {
			case DisplayMode::FullScreen:
				//tXN[
				d3dpp.Windowed         = FALSE;
				d3dpp.BackBufferWidth  = 640;
				d3dpp.BackBufferHeight = 480;
				d3dpp.BackBufferFormat = D3DFMT_X8R8G8B8;
				d3dpp.BackBufferCount  = 1;
				d3dpp.SwapEffect       = D3DSWAPEFFECT_DISCARD;
				d3dpp.FullScreen_RefreshRateInHz = 60;
				break;
			case DisplayMode::WindowMode:
				//EBhE[h
				d3dpp.Windowed			= TRUE;
				//d3dpp.BackBufferWidth   = 640;
				//d3dpp.BackBufferHeight  = 480;
				d3dpp.SwapEffect		= D3DSWAPEFFECT_DISCARD;
				d3dpp.BackBufferFormat	= dmode.Format;
				d3dpp.BackBufferCount	= 1;	
				break;
		}

		//Zobt@̐ݒ
		d3dpp.EnableAutoDepthStencil = true;
		d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

	}

	//fBXvCA_v^\߂̃foCX쐬
	//`揈@ƒ_@̓n[hEFAΉłƎŝŁA@̑gݍ킹ςčēx쐬݂
	HRESULT		hr;
	D3DDEVTYPE	devtype;
	DWORD		behaviorFlags;
	for ( int c = 0; c < 4; c++ ) {
		switch ( c ) {
            case 0:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;						
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 1:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
			case 2:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 3:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;						
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
		}
	
		hr = g_pD3D->CreateDevice(
						D3DADAPTER_DEFAULT,
						devtype,
						hWnd,
						behaviorFlags,
						&d3dpp,
						&g_pD3DDevice );
		
		
		if ( FAILED(hr) ) {
			continue;
		}
		break;
	}

	if ( FAILED(hr) ) {
		//\tgEFAɂΉĂȂ
		return false;
	}

	g_pD3DDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
	g_pD3DDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
	g_pD3DDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	
	//r[(J)̐ݒ
	D3DXMATRIX d3dxmatView;
	D3DXMatrixLookAtLH(
	  &d3dxmatView,
	  &(D3DXVECTOR3(-2.0f, 0.0f,-2.0f)), // J̈ʒu
	  &(D3DXVECTOR3(0.0f, 0.0f, 0.0f)),  // _̈ʒu
	  &(D3DXVECTOR3(0.0f, 1.0f, 0.0f))   // J猩̃xNg
	);
	GetDevice()->SetTransform( D3DTS_VIEW, &d3dxmatView );

	//vWFNV(ˉe)̐ݒ
	D3DXMATRIX matBaseProj;	
	D3DXMatrixPerspectiveFovLH(
			&matBaseProj,
			(float)(3.141592/4.0),	//p
			(float)(640.0/480.0),	//AXyNg
			1.0f,               //NbsOi߂قj
			1000000.0f);        //NbsOiق)
	GetDevice()->SetTransform( D3DTS_PROJECTION, &matBaseProj );

	//Cg̐ݒ
	GetDevice()->SetRenderState(D3DRS_LIGHTING,TRUE);
	D3DLIGHT9	light;
	::ZeroMemory(&light, sizeof(D3DLIGHT9));
	light.Type = D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r  = 0.9f;   light.Diffuse.g = 0.9f;   light.Diffuse.b = 0.9f;
	light.Specular.r = 0.2f;  light.Specular.g = 0.2f;  light.Specular.b = 0.2f;
	light.Ambient.r  = 0.5f;   light.Ambient.g = 0.5f;   light.Ambient.b = 0.5f;
	light.Direction = D3DXVECTOR3(0.0f, -0.5f, -0.2f);
	GetDevice()->SetLight(0, &light);
	GetDevice()->LightEnable(0, TRUE);

	return true;
}

//`OɌĂ
void CGraphic::ClearAndBegin()
{
	//ʃNA
	//D3DCLEAR_ZBUFFERtOȂAD3DPRESENT_PARAMETERSZobt@̐ݒ邱ƁBiȂƕ\ςɂȂj
	g_pD3DDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, m_backColor, 1.0f, 0L );

	//foCXɕ`Jnm点
	g_pD3DDevice->BeginScene();
}

//`ɌĂ
void CGraphic::EndAndPresent()
{
	//foCXɕ`Im点
	g_pD3DDevice->EndScene();
	
	//ʂobNobt@ƓւB
	g_pD3DDevice->Present( NULL, NULL, NULL, NULL );
}